require "base64"

module DataStory
  class DataURI
    
    # Public: Generates a data uri from a file type and data.
    def self.from_data(file_type, data)
      encoded_data = Base64.strict_encode64(data)
      "data:#{file_type};base64,%s" % encoded_data
    end
    
    # Public: Loads the file at file_path and converts it to a data uri.
    def self.from_file(path)
      file_type = `file --mime -b #{path}`
      
      data = nil
      File.open(path, "rb") do |file|
        data = file.read
      end

      from_data(file_type, data)
    end
  end
end